From 03267369cc22d3d7030d8d291f7b6ce5425bc040 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 27 2020 20:12:17 +0000
Subject: [PATCH 1797/2232] Consolidate error on unsized extern Rust type


---

diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 69c90eb..580ff76 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -691,19 +691,25 @@ fn expand_rust_type_layout(ety: &ExternType) -> TokenStream {
     let link_sizeof = mangle::operator(&ety.name, "sizeof");
     let link_alignof = mangle::operator(&ety.name, "alignof");
 
+    let local_layout = format_ident!("__layout_{}", ety.name.rust);
     let local_sizeof = format_ident!("__sizeof_{}", ety.name.rust);
     let local_alignof = format_ident!("__alignof_{}", ety.name.rust);
 
     quote_spanned! {span=>
         #[doc(hidden)]
+        #[inline]
+        fn #local_layout() -> ::std::alloc::Layout {
+            ::std::alloc::Layout::new::<#ident>()
+        }
+        #[doc(hidden)]
         #[export_name = #link_sizeof]
         extern "C" fn #local_sizeof() -> usize {
-            ::std::mem::size_of::<#ident>()
+            #local_layout().size()
         }
         #[doc(hidden)]
         #[export_name = #link_alignof]
         extern "C" fn #local_alignof() -> usize {
-            ::std::mem::align_of::<#ident>()
+            #local_layout().align()
         }
     }
 }
diff --git a/tests/ui/opaque_not_sized.stderr b/tests/ui/opaque_not_sized.stderr
index 75773b6..b400908 100644
--- a/tests/ui/opaque_not_sized.stderr
+++ b/tests/ui/opaque_not_sized.stderr
@@ -18,12 +18,3 @@ error[E0277]: the size for values of type `str` cannot be known at compilation t
     |
     = help: within `TypeR`, the trait `Sized` is not implemented for `str`
     = note: required because it appears within the type `TypeR`
-
-error[E0277]: the size for values of type `str` cannot be known at compilation time
-   --> $DIR/opaque_not_sized.rs:4:14
-    |
-4   |         type TypeR;
-    |              ^^^^^ doesn't have a size known at compile-time
-    |
-    = help: within `TypeR`, the trait `Sized` is not implemented for `str`
-    = note: required because it appears within the type `TypeR`

